//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;
using Tecan.Sila2.Interop.Server.BasicDataTypesTest;


namespace Tecan.Sila2.Auth.BasicDataTypesTest
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Echo String Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoStringValueRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _stringValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoStringValueRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoStringValueRequestDto(string stringValue, Tecan.Sila2.IBinaryStore store)
        {
            StringValue = new Tecan.Sila2.StringDto(stringValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto StringValue
        {
            get
            {
                return _stringValue;
            }
            set
            {
                _stringValue = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoStringValue";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(StringValue, "stringValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(StringValue, "stringValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo String Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoStringValueResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _receivedValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoStringValueResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoStringValueResponseDto(string receivedValue, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValue = new Tecan.Sila2.StringDto(receivedValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto ReceivedValue
        {
            get
            {
                return _receivedValue;
            }
            set
            {
                _receivedValue = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValue, "receivedValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValue, "receivedValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Integer Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoIntegerValueRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.IntegerDto _integerValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoIntegerValueRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoIntegerValueRequestDto(long integerValue, Tecan.Sila2.IBinaryStore store)
        {
            IntegerValue = new Tecan.Sila2.IntegerDto(integerValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto IntegerValue
        {
            get
            {
                return _integerValue;
            }
            set
            {
                _integerValue = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoIntegerValue";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(IntegerValue, "integerValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(IntegerValue, "integerValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Integer Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoIntegerValueResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.IntegerDto _receivedValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoIntegerValueResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoIntegerValueResponseDto(long receivedValue, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValue = new Tecan.Sila2.IntegerDto(receivedValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto ReceivedValue
        {
            get
            {
                return _receivedValue;
            }
            set
            {
                _receivedValue = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValue, "receivedValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValue, "receivedValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Real Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoRealValueRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.RealDto _realValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoRealValueRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoRealValueRequestDto(double realValue, Tecan.Sila2.IBinaryStore store)
        {
            RealValue = new Tecan.Sila2.RealDto(realValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.RealDto RealValue
        {
            get
            {
                return _realValue;
            }
            set
            {
                _realValue = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoRealValue";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(RealValue, "realValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(RealValue, "realValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Real Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoRealValueResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.RealDto _receivedValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoRealValueResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoRealValueResponseDto(double receivedValue, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValue = new Tecan.Sila2.RealDto(receivedValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.RealDto ReceivedValue
        {
            get
            {
                return _receivedValue;
            }
            set
            {
                _receivedValue = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValue, "receivedValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValue, "receivedValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Boolean Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoBooleanValueRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.BooleanDto _booleanValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoBooleanValueRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoBooleanValueRequestDto(bool booleanValue, Tecan.Sila2.IBinaryStore store)
        {
            BooleanValue = new Tecan.Sila2.BooleanDto(booleanValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.BooleanDto BooleanValue
        {
            get
            {
                return _booleanValue;
            }
            set
            {
                _booleanValue = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoBooleanValue";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(BooleanValue, "booleanValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(BooleanValue, "booleanValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Boolean Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoBooleanValueResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.BooleanDto _receivedValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoBooleanValueResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoBooleanValueResponseDto(bool receivedValue, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValue = new Tecan.Sila2.BooleanDto(receivedValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.BooleanDto ReceivedValue
        {
            get
            {
                return _receivedValue;
            }
            set
            {
                _receivedValue = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValue, "receivedValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValue, "receivedValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Date Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoDateValueRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.TimestampDto _dateValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoDateValueRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoDateValueRequestDto(System.DateTimeOffset dateValue, Tecan.Sila2.IBinaryStore store)
        {
            DateValue = new Tecan.Sila2.TimestampDto(dateValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.TimestampDto DateValue
        {
            get
            {
                return _dateValue;
            }
            set
            {
                _dateValue = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoDateValue";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(DateValue, "dateValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(DateValue, "dateValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Date Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoDateValueResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.TimestampDto _receivedValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoDateValueResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoDateValueResponseDto(System.DateTimeOffset receivedValue, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValue = new Tecan.Sila2.TimestampDto(receivedValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.TimestampDto ReceivedValue
        {
            get
            {
                return _receivedValue;
            }
            set
            {
                _receivedValue = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValue, "receivedValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValue, "receivedValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Time Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoTimeValueRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.TimeDto _timeValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoTimeValueRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoTimeValueRequestDto(System.TimeSpan timeValue, Tecan.Sila2.IBinaryStore store)
        {
            TimeValue = new Tecan.Sila2.TimeDto(timeValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.TimeDto TimeValue
        {
            get
            {
                return _timeValue;
            }
            set
            {
                _timeValue = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoTimeValue";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(TimeValue, "timeValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(TimeValue, "timeValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Time Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoTimeValueResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.TimeDto _receivedValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoTimeValueResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoTimeValueResponseDto(System.TimeSpan receivedValue, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValue = new Tecan.Sila2.TimeDto(receivedValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.TimeDto ReceivedValue
        {
            get
            {
                return _receivedValue;
            }
            set
            {
                _receivedValue = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValue, "receivedValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValue, "receivedValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Timestamp Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoTimestampValueRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.TimestampDto _timestampValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoTimestampValueRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoTimestampValueRequestDto(System.DateTimeOffset timestampValue, Tecan.Sila2.IBinaryStore store)
        {
            TimestampValue = new Tecan.Sila2.TimestampDto(timestampValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.TimestampDto TimestampValue
        {
            get
            {
                return _timestampValue;
            }
            set
            {
                _timestampValue = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoTimestampValue";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(TimestampValue, "timestampValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(TimestampValue, "timestampValue"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Timestamp Value command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoTimestampValueResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.TimestampDto _receivedValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoTimestampValueResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public EchoTimestampValueResponseDto(System.DateTimeOffset receivedValue, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValue = new Tecan.Sila2.TimestampDto(receivedValue, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.TimestampDto ReceivedValue
        {
            get
            {
                return _receivedValue;
            }
            set
            {
                _receivedValue = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValue, "receivedValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValue, "receivedValue"));
        }
    }
}

